# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "ax-hal"
version = "0.5.27"
authors = ["Yuekai Jia <equation618@gmail.com>"]
build = "build.rs"
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "ArceOS hardware abstraction layer, provides unified APIs for platform-specific operations"
readme = "README.md"
license = "Apache-2.0"
repository = "https://github.com/rcore-os/tgoskits"

[features]
default = []
fp-simd = [
    "ax-cpu/fp-simd",
    "axplat-dyn/fp-simd",
]
host-test = []
hv = [
    "paging",
    "ax-cpu/arm-el2",
    "ax-cpu/exception-table",
    "ax-percpu/arm-el2",
    "axplat-dyn/hv",
]
ipi = ["irq"]
irq = [
    "ax-plat/irq",
    "axplat-dyn/irq",
    "dep:ax-kspin",
]
paging = [
    "dep:ax-alloc",
    "dep:ax-page-table-multiarch",
    "ax-page-table-multiarch/ax-errno",
]
rtc = ["axplat-dyn/rtc"]
smp = [
    "axplat-dyn/smp",
    "ax-plat/smp",
]
tls = ["ax-cpu/tls"]
uspace = [
    "paging",
    "ax-cpu/uspace",
    "axplat-dyn/uspace",
]
xuantie-c9xx = ["ax-cpu/xuantie-c9xx"]

[lib]
name = "ax_hal"
path = "src/lib.rs"

[dependencies.ax-alloc]
version = "0.8.11"
optional = true
default-features = false

[dependencies.ax-cpu]
version = "0.8.3"

[dependencies.ax-kernel-guard]
version = "0.3.11"

[dependencies.ax-kspin]
version = "0.3.15"
optional = true

[dependencies.ax-memory-addr]
version = "0.6.9"

[dependencies.ax-page-table-multiarch]
version = "0.8.13"
optional = true

[dependencies.ax-percpu]
version = "0.4.14"
features = ["non-zero-vma"]

[dependencies.ax-plat]
version = "0.11.0"

[dependencies.axplat-dyn]
version = "0.7.11"
default-features = false

[dependencies.cfg-if]
version = "1.0"

[dependencies.fdt-parser]
version = "0.4"

[dependencies.heapless]
version = "0.9"

[dependencies.log]
version = "0.4"

[dependencies.rdrive]
version = "0.23.5"

[dependencies.spin]
version = "=0.12.0"
features = [
    "lock_api",
    "once",
    "lazylock",
]
default-features = false

[build-dependencies.quote]
version = "1.0"
